"use client"

import LoadingItem from "@/components/loading-item";
import { Separator } from "@/components/ui/separator";
import { useEffect } from "react";
import { useInView } from "react-intersection-observer";
import { IInfiniteGweets } from "../types";
import { Gweet } from "./gweet";

export const InfiniteGweets = ({
  gweets,
  isSuccess,
  isFetchingNextPage,
  fetchNextPage,
  hasNextPage,
}: {
  gweets: IInfiniteGweets;
  isSuccess: boolean | undefined;
  isFetchingNextPage: boolean | undefined;
  fetchNextPage: () => Promise<any> | void;
  hasNextPage: boolean | undefined;
}) => {
  const { ref, inView } = useInView();

  useEffect(() => {
    if (inView && hasNextPage) {
      fetchNextPage();
    }
  }, [inView, hasNextPage, fetchNextPage]);

  return (
    <div>
      {isSuccess &&
        gweets?.pages?.map((page) => {
          return page?.gweets?.map((gweet, index) => (
            <div
              ref={index === page.gweets.length - 4 ? ref : undefined}
              key={gweet.id}
            >
              <Gweet gweet={gweet} />
              <div className="px-6">
                <Separator className="my-3" />
              </div>
            </div>
          ));
        })}

      {isFetchingNextPage && <LoadingItem />}
    </div>
  );
};