import { useQuery, useQueryClient } from "@tanstack/react-query";

import getGweet from "../api/get-gweet";
import { IGweet } from "../types";

export const useGweet = (id: string | undefined) => {
  const queryClient = useQueryClient();
  return useQuery<IGweet>(
    ["gweets", id],
    async () => {
      return getGweet(id);
    },
    {
      refetchOnWindowFocus: false,
      onSuccess: (data) => {
        queryClient.setQueryData(["gweets", id], data);
      },
    },
  );
};
